package ca.carleton.gcrc.couch.client;

import java.net.URL;
import java.util.List;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

public interface CouchClient {

	CouchContext getContext();
	
	URL getUrl();
	
	CouchServerVersion getVersion() throws Exception;
	
	CouchSession getSession() throws Exception;

	String getUuid() throws Exception;
	
	List<String> listDatabases() throws Exception;
	
	CouchDb createDatabase(String dbName) throws Exception;

	boolean databaseExists(String dbName) throws Exception;

	CouchDb getDatabase(String dbName) throws Exception;

	void deleteDatabase(CouchDb couchDb) throws Exception;

	CouchUserDb getUserDatabase() throws Exception;
	
	JSONObject replicate(ReplicationRequest replicationRequest) throws Exception;
	
	JSONArray activeTasks() throws Exception;
}
